%{
#include <stdio.h>

/* Not done in the spirit of success/failure because we intend to return
   SUCCESS all the time. 						*/
#ifdef VMS
#define SS_SUCCESS 1
#define SHELLC '$'
#else
#define SS_SUCCESS 0
#define SHELLC '%'
#endif
#ifndef TRUE
#define TRUE  (1==1)
#endif
#ifndef FALSE
#define FALSE (1==0)
#endif

void	print_help(char **);
void	check_char(int);
void	comment(void);

char	VERSION[]="V01-110";
char	UPDATED[]="22-Jun-2000";

#define NUMMODE 5
char	*PRT_OPEN[NUMMODE]={"printf(","print ","fprintf(FO,","printf FO ","cout << "};
char	*PRT_CLOSE[NUMMODE]={")","",")","",""};

int	num_char=0;
int     LENGTH = 60;
short int mode = 0;
short int macro= FALSE;
short int as_is= FALSE;
short int do_fp= FALSE;
short int FIRST= 1;


#define YY_USER_ACTION	if(FIRST){comment();}
#define YY_USER_INIT {if ( mode == 1) BEGIN(perl);}

%}


%s perl
%%
\t			fprintf(yyout,"\\t");check_char(2);
\n|(\015|\015\012)\n	fprintf(yyout,"\\n");check_char(as_is?0:2);
\010			fprintf(yyout,"\\b");check_char(2);
\015			fprintf(yyout,"\\r");check_char(2);
\014			fprintf(yyout,"\\f");check_char(2);
<perl>"$"|"@"		fprintf(yyout,"\\%s",yytext);
			check_char(2);
"%"			if(macro){ 
				fprintf(yyout,"%%");
				check_char(1);
			} else {
				fprintf(yyout,"%%%%");
				check_char(2);
			}
\134|\042		fprintf(yyout,"\\%s",yytext);check_char(2);
.			fprintf(yyout,yytext);check_char(1);
<<EOF>>			fprintf(yyout,"\"%s;",PRT_CLOSE[mode]); yyterminate();
%%


int main(int argc,char **argv )
{
  int i;
  
  for(i=1 ; i < argc ; i++){
    if (strcmp(argv[i],"-h") == 0){
      print_help(argv);
      
    } else if (strcmp(argv[i],"-p") == 0){
      mode = 1;
    } else if (strcmp(argv[i],"-x") == 0){
      mode = 4;
    } else if (strcmp(argv[i],"-f") == 0){
      do_fp= TRUE;
    } else if(strcmp(argv[i],"-l") == 0){
      if( i != (argc-1) ){
	LENGTH = atoi(argv[++i]);
	if( LENGTH <= 0){
	  fprintf(stderr,"text2c :: 0 or negative value with -l option is not valid\n");
	  return SS_SUCCESS;
	}
      } else {
	fprintf(stderr,"text2c :: Not enough arguments\n");
	return SS_SUCCESS;
      }
    } else if (strcmp(argv[i],"-m") == 0){
      macro= TRUE;
    } else if (strcmp(argv[i],"-w") == 0){
      as_is= TRUE;
    } else {
      if( ! yyin ) yyin = fopen( argv[i], "r" );
      else yyout = fopen( argv[i], "w" );
    }
  }
  /* Small user warning 						*/
  if(do_fp){
    if(mode <= 2){
	mode += 2;
    } else {
        fprintf(stderr,"text2c :: Options compatible with -f");
    }
  }

  
  yylex();
  return SS_SUCCESS;
}



void comment()
{
 if(yyout != stdout){
#ifdef YY_FLEX_MAJOR_VERSION
   fprintf(yyout,"  %s Formatted by text2c %s (Flex V%d.%d). Last update %s %s\n",
     (mode==1||mode==3?"#":"/*"),
     VERSION,YY_FLEX_MAJOR_VERSION,YY_FLEX_MINOR_VERSION,UPDATED,
     (mode==1||mode==3?"":"*/"));
#else
   fprintf(yyout,"  %s Formatted by text2c %s (Flex). Last update %s %s\n",
     (mode==1||mode==3?"#":"/*"),
     VERSION,UPDATED,
     (mode==1||mode==3?"":"*/"));
#endif
 }
 fprintf(yyout,"  %s\"",PRT_OPEN[mode]);
 FIRST = !FIRST;
}


void check_char(int n)
{
  if( (num_char >= LENGTH && ! as_is) || (n == 0 && as_is ) ){
      fprintf(yyout,"\"%s;\n  %s\"",PRT_CLOSE[mode],PRT_OPEN[mode]);
      num_char	= 0;
  } else {
      num_char += n;
  }
}



void print_help(char **argv)
{
  char    *p_nom                  ;

#ifdef VMS
  p_nom   = (char *) strrchr(argv[0], ']');
#else
  p_nom   = (char *) strrchr(argv[0], '/');
  if(! p_nom) p_nom = argv[0];
#endif
  p_nom   = &p_nom[1];
  printf("\nTEXT2C version %s. Copyright (C) 1998-2000 Jrme LAURET\n\n",VERSION);
  printf("This is a txt2c filter that converts  a regular text file into print\n");
  printf("statements  to be  included into your C,  C++ or perl  programs. The \n");
  printf("default is to output C printf() statements.\n");
  printf("\nUsage is : %c %s [options] [InputFile] [OutputFile]\n",
	SHELLC,p_nom);
  printf("Options are : \n");
  printf("   -h     shows this help\n");
  printf("   -p     perl print statements\n");
  printf("   -x     C++ cout statements\n");
  printf("   -f     use file handler style\n");
  printf("   -m     Do not format %%\n");
  printf("   -w     Format as-is (no line wrap)\n");
  printf("   -l x   output 'x' characters per line.\n\n");
  printf("If you have any  suggestions, comments, or updates to this  utility,\n");
  printf("please Email me at jlauret@mail.chem.sunysb.edu.\n\n");
  exit(SS_SUCCESS);
}

